
import React, { Component } from 'react';
import { Panel, Button, Modal,Alert ,Confirm,Popup,StaticModal} from '../../components';

import '../styles/pages/ModalPage';

class ModalPage extends Component {

  constructor(props) {
    super(props);
    this.state = {
      props  : {},
      modal  : false,
      dialog : false,
      alert  : false,
      confirm: false,
      popup:false
    };
  }

  open(key, props) {
    this.setState({
      [`${key}`]: true,
      props
    });
  }

  close(key) {
    this.setState({
      [`${key}`]: false,
    });
  }
  _StaticAlert(){ 
    //静态alert 提示框，不用引入组件，可直接使用方法调用
    StaticModal.alert({
      id:"12",
      autoClose:1,
      className:"test11",
      theme:"info",
      cancelText:"确定了",
      message:(<p>这是一个静态提示组件，不用引入Alert，直接function 调用的哦！</p>),
      onClose:()=>{
        StaticModal.remove("12");
      }
    });
  }
  _StaticConfirm(){
    //静态Confirm 确认框，不用引入组件，可直接使用方法调用
    StaticModal.confirm({
      // autoClose:1,
      // className:"test11",
      theme:"default",
      okText:"是",
      cancelText:"否",
      message:(<p>这是一个静态确认组件，不用引入Comfirm，调用的哦！</p>),
      onCancel:()=>{
        console.log("取消了………………")
      },
      onOk:()=>{
        StaticModal.alert({
          message:(<p>这是一个由confirm确认框，点确定后弹出的下一步弹窗！</p>),
          onClose:()=>{
          }
        });
      }
    });
  }
  _StaticCustom(){
    //静态自定义模态框，不用引入组件，可直接使用方法调用
    StaticModal.custom({
      id:"custom",
      className:"test-modal",
      children:(<div><p>静态自定义模态框，不用引入组件，可直接使用方法调用，调用的哦！,没写样式有点丑<br/><br/></p><p><Button size="sm" radius theme="info" block onClick={() =>StaticModal.remove("custom") }>关闭自定义弹框</Button></p></div>),
      onClick:()=>{
        console.log("取消了………………")
      }
    });
  }
  render() {

    return (
      <div className="modal-page">

        <Panel>
          <Panel.Header>
            <Panel.Title>普通模态框</Panel.Title>
          </Panel.Header>
          <Panel.Body>
            <Button radius size="sm" onClick={() => this.open('modal', {})}>打开</Button>
          </Panel.Body>
        </Panel>

        <Panel>
          <Panel.Header>
            <Panel.Title>点击遮罩层可以关闭的模态框</Panel.Title>
          </Panel.Header>
          <Panel.Body>
            <Button radius size="sm" onClick={() => this.open('modal', {
              onMaskClick: () => this.close('modal')
            })}>打开</Button>
          </Panel.Body>
        </Panel>
        <Panel>
          <Panel.Header>
            <Panel.Title>Popup 特殊底部弹出的模态框</Panel.Title>
          </Panel.Header>
          <Panel.Body>
            <Button radius theme="info" size="sm" onClick={() => this.open('popup', {
              onMaskClick: () => this.close('popup')
            })}>特殊模态框</Button>
          </Panel.Body>
        </Panel>

        <Panel>
          <Panel.Header>
            <Panel.Title>Dialog、Alert、Confirm模式的模态框</Panel.Title>
          </Panel.Header>
          <Panel.Body>
            <Button radius size="sm" onClick={() => this.open('dialog', {
              onMaskClick: () => this.close('dialog')
            })}>Dialog</Button>
            <Button radius size="sm" theme="info" onClick={() => this.open('alert', {})}>Alert</Button>
            <Button radius size="sm" theme="warning" onClick={() => this.open('confirm', {})}>Confirm</Button>
          </Panel.Body>
        </Panel>
        <Panel>
          <Panel.Header>
            <Panel.Title>静态提示组件（Alert、Confirm）</Panel.Title>
          </Panel.Header>
          <Panel.Body>
            <Button size="sm" theme="warning" onClick={() => this._StaticAlert()}>静态警告框</Button>
              <Button size="sm" isBordered theme="info" onClick={() => this._StaticConfirm()}>静态确认弹框</Button>
              <Button size="sm" isBordered theme="success" onClick={() => this._StaticCustom()}>静态自定义弹框</Button>
          </Panel.Body>
        </Panel>
        <Panel>
          <Panel.Header>
            <Panel.Title>圆角模态框</Panel.Title>
          </Panel.Header>
          <Panel.Body>
            <Button radius size="sm" onClick={() => this.open('modal', { isRadius: true })}>打开</Button>
          </Panel.Body>
        </Panel>

        <Modal {...this.state.props} visible={this.state.modal}>
          <Modal.Header title="标题" onClose={() => this.close('modal')}></Modal.Header>
          <Modal.Body>
            模态框内容
          </Modal.Body>
          <Modal.Footer>
            <Button radius block bordered size="sm" onClick={() => this.close('modal')}>取消</Button>
            <Button radius block size="sm" theme="success" onClick={() => { alert('你点击了确定') }}>确定</Button>
          </Modal.Footer>
        </Modal>

        <Modal {...this.state.props} visible={this.state.dialog}>
          <Modal.Header title="标题" onClose={() => this.close('dialog')}></Modal.Header>
          <Modal.Body>
            模态框内容
          </Modal.Body>
        </Modal>

        <Alert
            isRadius={true}
            title="标题"
            visible={this.state.alert}
            message={(<p>这里是警告信息</p>)}
            onCancel={() => this.close('alert')}
            />
        <Confirm
          isRadius={true}
          title="提示"
          visible={this.state.confirm}
          message={(<p>你确定要这样做吗？</p>)}
          onOk={() => alert('click ok')}
          onCancel={() => this.close('confirm')}
          />
          <Popup
             {...this.state.props}
            visible={this.state.popup}
            title="特殊模态框"
            onMaskClick={() => this.close('popup')}>
              <div className="test-popup">
                <p>测试的内容</p>
                <p>测试的内容</p>
                <p>测试的内容</p>
                <p>测试的内容</p>
                <p>测试的内容</p>
                <p>测试的内容</p>
                <p>测试的内容</p>
                <p>测试的内容</p>
                <p>测试的内容</p>
              </div>
          </Popup>
          <p style={{height:1000}}></p>
      </div>
    );
  }
}

export default ModalPage;