'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _uiFormat = require('../utils/uiFormat');

var _uiFormat2 = _interopRequireDefault(_uiFormat);

var _photoswipe = require('photoswipe');

var _photoswipe2 = _interopRequireDefault(_photoswipe);

var _photoswipeUiDefault = require('photoswipe/dist/photoswipe-ui-default');

var _photoswipeUiDefault2 = _interopRequireDefault(_photoswipeUiDefault);

require('photoswipe/dist/photoswipe.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
// import Events from "min-bridge/lib/Events";

// import 'photoswipe/dist/default-skin/default-skin.css';


var PreviewSwipe = function (_Component) {
	_inherits(PreviewSwipe, _Component);

	function PreviewSwipe(props) {
		_classCallCheck(this, PreviewSwipe);

		var _this = _possibleConstructorReturn(this, (PreviewSwipe.__proto__ || Object.getPrototypeOf(PreviewSwipe)).call(this, props));

		_this.imgitems = [];
		_this.bailor = props.bailor || "body";
		_this.photoPreview = null;
		_this.bindEvent = _this.bindEvent.bind(_this);
		return _this;
	}

	_createClass(PreviewSwipe, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			_uiFormat2.default.$Q(this.bailor) && _uiFormat2.default.$Q(this.bailor).addEventListener("click", this.bindEvent);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.photoPreview = null;
			this.imgitems = [];
			_uiFormat2.default.$Q(this.bailor) && _uiFormat2.default.$Q(this.bailor).removeEventListener("click", this.bindEvent);
		}
	}, {
		key: 'bindEvent',
		value: function bindEvent(e) {
			var _this2 = this;

			var zoomImg = _uiFormat2.default.$Q(this.bailor).querySelectorAll(".zoom-img");
			// let _className ="zoom-img";
			// var reg = new RegExp("(?:^|\s+)"+_className+"(?:\s+|$)","g");
			if (zoomImg.length > 0 && e.target.className.indexOf('zoom-img') != -1) {
				//console.log(this.imgitems.length , zoomImg.length)
				if (this.imgitems.length == zoomImg.length) {
					this.previewInit(this.getIndex(e.target, this.imgitems), this.imgitems, zoomImg);
				} else {
					this.getList(zoomImg, function (arrList) {
						_this2.imgitems = arrList;
					}, e.target);
				}
				return true;
			};
		}
	}, {
		key: 'getIndex',
		value: function getIndex(el, list) {
			var _href = el.getAttribute("href") || el.src;
			return list.findIndex(function (item) {
				return item.src == _href;
			});
		}
	}, {
		key: 'getList',
		value: function getList(eleList, callback, target) {
			var _this3 = this;

			var arr = [];
			var _that = this;
			for (var i = 0; i < eleList.length; i++) {
				var imgs = eleList[i];
				this.imgLoad(imgs, i, function (imgobj, index) {
					arr[index] = imgobj;
					var targetHref = target.getAttribute("href") || target.src;
					var activeHref = imgobj.src;
					if (targetHref == activeHref) {
						_this3.previewInit(index, arr, eleList);
					}
				});
			};
			callback && callback(arr);
		}
	}, {
		key: 'imgLoad',
		value: function imgLoad(target, i, _callback) {
			//本站相册初始为loading图片，真实图片放在data-src
			var ds = target.getAttribute("href");
			//创建image对象，用于获取图片宽高
			var imgtemp = new Image();
			//判断是否存在data-src
			if (ds != null && ds.length > 0) {
				imgtemp.src = ds;
			} else {
				imgtemp.src = target.src;
			};
			//判断是否存在缓存
			if (imgtemp.complete) {
				var imgobj = {
					"src": imgtemp.src,
					"w": imgtemp.width,
					"h": imgtemp.height
					// "msrc": "/static/img/preloader.gif"
				};
				// arr[i] = ;
				_callback && _callback(imgobj, i);
				// 
			} else {
				imgtemp.index = i;
				imgtemp.img = target;
				imgtemp.onload = function () {
					var imgobj = {
						"src": this.src,
						"w": this.width,
						"h": this.height
						// "msrc": "/static/img/preloader.gif"
					};
					//不要使用push，因为onload前后顺序会不同
					// arr[this.index] = imgobj

					_callback && _callback(imgobj, this.index);
					//添加点击事件
					// _that.addImgClick(this.index,arr);
				};
			}
		}
	}, {
		key: 'previewInit',
		value: function previewInit(index, List, souceList) {

			var pswpElement = document.querySelectorAll('.pswp')[0];
			// build items array
			// define options (if needed)
			var options = {
				// history & focus options are disabled on CodePen        

				/*focus: false,
    showAnimationDuration:150,
    hideAnimationDuration:150,
    mainClass :'pswp--minimal--dark',
    galleryUID: galleryElement.getAttribute('data-pswp-uid'),
    barsSize : {top:0,bottom:0},
    tapToToggleControls :false,*/
				index: index,
				history: false,
				getThumbBoundsFn: function getThumbBoundsFn(i) {
					var thumbnail = souceList[index],
					    // find thumbnail
					pageYScroll = window.pageYOffset || document.documentElement.scrollTop,
					    rect = thumbnail.getBoundingClientRect();
					return { x: rect.left, y: rect.top + pageYScroll, w: rect.width };
				},
				captionEl: false,
				fullscreenEl: false,
				shareEl: false,
				bgOpacity: 0.9,
				tapToClose: true
			};
			this.photoPreview = new _photoswipe2.default(pswpElement, _photoswipeUiDefault2.default, List, options);
			this.photoPreview.init();
		}
	}, {
		key: 'render',
		value: function render() {
			return _react2.default.createElement(
				'div',
				{ className: 'pswp', tabIndex: '-1', role: 'dialog' },
				_react2.default.createElement('div', { className: 'pswp__bg' }),
				_react2.default.createElement(
					'div',
					{ className: 'pswp__scroll-wrap' },
					_react2.default.createElement(
						'div',
						{ className: 'pswp__container' },
						_react2.default.createElement('div', { className: 'pswp__item' }),
						_react2.default.createElement('div', { className: 'pswp__item' }),
						_react2.default.createElement('div', { className: 'pswp__item' })
					),
					_react2.default.createElement(
						'div',
						{ className: 'pswp__ui pswp__ui--hidden' },
						_react2.default.createElement(
							'div',
							{ className: 'pswp__top-bar' },
							_react2.default.createElement('div', { className: 'pswp__counter' }),
							_react2.default.createElement('button', { className: 'pswp__button pswp__button--close', title: 'Close (Esc)' }),
							_react2.default.createElement('button', { className: 'pswp__button pswp__button--share', title: 'Share' }),
							_react2.default.createElement('button', { className: 'pswp__button pswp__button--fs', title: 'Toggle fullscreen' }),
							_react2.default.createElement('button', { className: 'pswp__button pswp__button--zoom', title: 'Zoom in/out' }),
							_react2.default.createElement(
								'div',
								{ className: 'pswp__preloader' },
								_react2.default.createElement(
									'div',
									{ className: 'pswp__preloader__icn' },
									_react2.default.createElement(
										'div',
										{ className: 'pswp__preloader__cut' },
										_react2.default.createElement('div', { className: 'pswp__preloader__donut' })
									)
								)
							)
						),
						_react2.default.createElement(
							'div',
							{ className: 'pswp__share-modal pswp__share-modal--hidden pswp__single-tap' },
							_react2.default.createElement('div', { className: 'pswp__share-tooltip' })
						),
						_react2.default.createElement('button', { className: 'pswp__button pswp__button--arrow--left', title: 'Previous (arrow left)' }),
						_react2.default.createElement('button', { className: 'pswp__button pswp__button--arrow--right', title: 'Next (arrow right)' }),
						_react2.default.createElement(
							'div',
							{ className: 'pswp__caption' },
							_react2.default.createElement('div', { className: 'pswp__caption__center' })
						)
					)
				)
			);
		}
	}]);

	return PreviewSwipe;
}(_react.Component);

exports.default = PreviewSwipe;