'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Icon = require('../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _uiFormat = require('../utils/uiFormat');

var _uiFormat2 = _interopRequireDefault(_uiFormat);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// import { mEvents } from 'min-bridge';

var Scrolls = function (_Component) {
	_inherits(Scrolls, _Component);

	function Scrolls(props) {
		_classCallCheck(this, Scrolls);

		var _this = _possibleConstructorReturn(this, (Scrolls.__proto__ || Object.getPrototypeOf(Scrolls)).call(this, props));

		_this.state = {
			upStatus: 1,
			initialize: false //是否初始化完成
		};
		_this.pullUpTips = {
			// 上拉状态
			0: '点击加载更多',
			1: '正在加载',
			2: '加载成功'
		};
		_this.pullUpIcon = {
			0: "arrow-top",
			1: "loading",
			2: "right-round-fill"
		};
		_this.timer = null;
		_this.scrollFlag = false;
		_this.clickFlag = false;
		_this.wh = (document.documentElement || window || document.body).clientHeight;

		_this.scrollPull = _this.scrollPull.bind(_this);
		_this.fetchComplete = _this.fetchComplete.bind(_this);
		return _this;
	}

	_createClass(Scrolls, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			document.addEventListener("scroll", this.scrollPull);
			var _props = this.props,
			    isInitialize = _props.isInitialize,
			    upFetch = _props.upFetch,
			    openUp = _props.openUp;

			isInitialize && upFetch && this.fetchComplete(upFetch); //初始化加载数据 
			(!isInitialize || !openUp) && this.setState({ initialize: true, upStatus: 0 });
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			clearTimeout(this.timer);
			document.removeEventListener("scroll", this.scrollPull);
		}
	}, {
		key: 'scrollPull',
		value: function scrollPull(type) {
			var _props2 = this.props,
			    distance = _props2.distance,
			    upFetch = _props2.upFetch;
			var openUp = this.props.openUp;

			var $moreTop = _uiFormat2.default.$Q("#pullUp").getBoundingClientRect().top;
			if (!this.scrollFlag && openUp) {
				// console.log($moreTop - distance <= this.wh,$moreTop , distance,this.wh)
				if ($moreTop - distance <= this.wh && openUp) {
					this.scrollFlag = true;
					clearTimeout(this.timer);
					upFetch && this.fetchComplete(upFetch);
				};
			};
		}
	}, {
		key: 'fetchComplete',
		value: function fetchComplete(callBack) {
			var _this2 = this;

			/*
       调用下拉，统一处理回调 
      * upFetch '上拉加载更多'  ,
     */
			if (this.clickFlag) {
				return false;
			};
			this.clickFlag = true;
			var re = /function\s*(\w*)/i;
			var matches = re.exec('' + callBack);
			this.setState({ upStatus: 1 }, function () {
				callBack && callBack().then(function () {
					__DEBUG__ && console.log((matches && matches[0]) + ' --scrolls-- \u8BF7\u6C42\u5B8C\u6210');
					_this2.cb();
				}, function () {
					__DEBUG__ && console.log((matches && matches[0]) + ' --scrolls-- \u8BF7\u6C42\u5F02\u5E38');
					_this2.cb();
				});
			});
		}
	}, {
		key: 'cb',
		value: function cb() {
			var _this3 = this;

			this.setState({ initialize: true, upStatus: 2 }, function () {
				clearTimeout(_this3.timer);
				_this3.scrollFlag = false;
				_this3.clickFlag = false;
				_this3.timer = setTimeout(function () {
					__DEBUG__ && console.log("cb------------回调完成----");
					_this3.setState({ upStatus: 0 });
				}, 1500);
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var _this4 = this;

			var _state = this.state,
			    initialize = _state.initialize,
			    upStatus = _state.upStatus;
			var _props3 = this.props,
			    tips = _props3.tips,
			    tipsTxt = _props3.tipsTxt,
			    children = _props3.children,
			    openUp = _props3.openUp,
			    upFetch = _props3.upFetch;

			return _react2.default.createElement(
				'div',
				{ className: 'ui-scroll-wrapper', id: 'scrollWrapper' },
				_react2.default.createElement(
					'div',
					{ className: 'ui-scroll-children' },
					children
				),
				_react2.default.createElement(
					'div',
					{ className: 'ui-scroll-footer', id: 'pullUp' },
					!!(!initialize || openUp) && _react2.default.createElement(
						'p',
						{ onClick: function onClick() {
								return initialize && upStatus == 0 && upFetch && _this4.fetchComplete(upFetch);
							}, className: (0, _classnames3.default)("ui-s-status more-load", _defineProperty({}, 'step' + upStatus, true)) },
						_react2.default.createElement(_Icon2.default, { className: 'scroll-icon sicon-' + this.pullUpIcon[upStatus], theme: 'info', type: this.pullUpIcon[upStatus] }),
						this.pullUpTips[upStatus]
					),
					!!(initialize && !openUp && tips) && _react2.default.createElement(
						'p',
						{ className: 'ui-s-status scroll-tips' },
						_react2.default.createElement(
							'span',
							null,
							tipsTxt
						)
					)
				)
			);
		}
	}]);

	return Scrolls;
}(_react.Component);

Scrolls.defaultProps = {
	openUp: false,
	tips: false,
	distance: 100, //距离底部目标多少就开始加载
	isInitialize: false, //初始是否自动加载数据
	tipsTxt: '已加载全部数据'
};

exports.default = Scrolls;