'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Alert = require('../Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _Confirm = require('../Confirm');

var _Confirm2 = _interopRequireDefault(_Confirm);

var _Modal = require('../Modal');

var _Modal2 = _interopRequireDefault(_Modal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var defaultModal = "default-modal";

//处理特殊处理
var idDispose = function idDispose(id) {
  var uid = id && id.replace(".", "-") || "";
  return defaultModal + (uid || "A".charCodeAt(0)) + 888;
};

var StaticModal = {
  default: function _default(options) {
    /*
     *  静态Alert、Comfirm 模态框 提示参数说明
     * @ param {Number} type 弹窗类型 1=alert,2=confirm
     * @ param {String} id 当前模态框的Id,用于删除时指定，默认可以不指定
     * @ param {Object} message 内容节点
     * @ param {fun} onClose 关闭的回调参数，
     * @ param {Boole} autoClose 布尔值，用于是否自动关闭弹窗
    */
    var _ref = options || {},
        id = _ref.id,
        message = _ref.message,
        onClose = _ref.onClose,
        autoClose = _ref.autoClose,
        _onOk = _ref.onOk,
        _onCancel = _ref.onCancel,
        children = _ref.children,
        _onClick = _ref.onClick,
        other = _objectWithoutProperties(_ref, ['id', 'message', 'onClose', 'autoClose', 'onOk', 'onCancel', 'children', 'onClick']);

    var div = document.createElement('div');
    div.id = idDispose(id) || defaultModal;
    document.body.appendChild(div);
    var cb = function cb() {
      if (!autoClose) {
        div && document.body.removeChild(div);
        div && setTimeout(function () {
          _reactDom2.default.unmountComponentAtNode(div);
        }, 0);
      };
    };
    if (!options.type) {
      //自定义的
      _reactDom2.default.render(_react2.default.createElement(
        _Modal2.default,
        _extends({ visible: true, onClick: function onClick() {
            cb && cb();
            _onClick && _onClick();
          } }, other),
        _react2.default.createElement(
          'div',
          null,
          children
        )
      ), div);
      return false;
    };
    _reactDom2.default.render(options.type == 1 ? _react2.default.createElement(_Alert2.default, _extends({}, other, {
      visible: true,
      onCancel: function onCancel() {
        cb && cb();
        onClose && onClose();
      },
      message: message || "" })) : _react2.default.createElement(_Confirm2.default, _extends({}, other, {
      visible: true,
      onCancel: function onCancel() {
        cb && cb();_onCancel && _onCancel();
      },
      onOk: function onOk() {
        cb && cb();_onOk && _onOk();
      },
      message: message || "" })), div);
  },
  alert: function alert(options) {
    options.type = 1;
    StaticModal.default(options);
  },
  confirm: function confirm(options) {
    options.type = 2; //"confirm";
    StaticModal.default(options);
  },
  custom: function custom(options) {
    StaticModal.default(options);
  },
  remove: function remove(id) {
    var defaultId = idDispose(id) || defaultModal;
    var loadNode = document.getElementById(defaultId);
    loadNode && document.body.removeChild(loadNode);
    loadNode && setTimeout(function () {
      _reactDom2.default.unmountComponentAtNode(loadNode);
    }, 0);
  }
};

exports.default = StaticModal;